#include "DataCrypt.h"
#include "BlowFish.h"
#include <stdlib.h>
#include <time.h>
#include <memory.h>

#define ENCRYPT_PWD_TEXT	"12Ha5364978xcb2o98m+"
#define ENCRYPT_PWD_SIZE	20

int IsEncryptedDataVax(char* pData, int nDataSize)
{
	char sDataOut[64000] = "\0";
	
	unsigned char sPwd[]  = ENCRYPT_PWD_TEXT;
	int nPwdSize = ENCRYPT_PWD_SIZE;
	
    InitializeBlowFish(sPwd, nPwdSize);
	DecodeBlowFish((unsigned char*) pData, (unsigned char*) sDataOut, nDataSize);
	    
    if(sDataOut[20] == 2 && sDataOut[21] == 26 && sDataOut[22] == 69 && sDataOut[23] == 23)
    {
        return 1;
    }
    
    return 0;
}

void EncryptDataVax(char* pDataIn, int nSizeDataIn, char* pDataOut, int* pSizeDataOut)
{
	char sInputData[64000] = "\0";
	int nCount = 0;
	unsigned char sPwd[] = ENCRYPT_PWD_TEXT;
	int nPwdSize = ENCRYPT_PWD_SIZE;
	
	srand((unsigned)time(NULL));
    	
	for(nCount = 0; nCount < 20; nCount++)
		sInputData[nCount] = rand();
	
	sInputData[20] = 2;
	sInputData[21] = 26;
	sInputData[22] = 69;
	sInputData[23] = 23;
    
	memcpy(&sInputData[24], &nSizeDataIn, 4);
	memcpy(&sInputData[28], pDataIn, nSizeDataIn);
			
	InitializeBlowFish(sPwd, nPwdSize);
	*pSizeDataOut = EncodeBlowFish((unsigned char*) sInputData, (unsigned char*) pDataOut, nSizeDataIn + 28);
}

void DecryptDataVax(char* pDataIn, int nSizeDataIn, char* pDataOut, int* pSizeDataOut)
{
	char sDataOut[64000] = "\0";
	int nSizeDataOut;
	int* pDataSize;
	unsigned char sPwd[] = ENCRYPT_PWD_TEXT;
	int nPwdSize = ENCRYPT_PWD_SIZE;
	
	if(!IsEncryptedDataVax(pDataIn, nSizeDataIn))
	{
		*pSizeDataOut = nSizeDataIn;
		memcpy(pDataOut, pDataIn, nSizeDataIn);
		return;
	}
					
	InitializeBlowFish(sPwd, nPwdSize);
	
	nSizeDataOut = GetOutputLengthBlowFish(nSizeDataIn);
	DecodeBlowFish((unsigned char*) pDataIn, (unsigned char*) sDataOut, nSizeDataIn);
	
	pDataSize = (int*) &sDataOut[24];
	*pSizeDataOut = *pDataSize;
    
	if(*pSizeDataOut >= 256)
	{
		*pSizeDataOut = 256;
    }
	
	memcpy(pDataOut, &sDataOut[28], *pSizeDataOut);
}

