#include "DataCrypt.h"
#include "BlowFish.h"
#include <stdlib.h>
#include <time.h>
#include <memory.h>

#define ENCRYPT_PWD_TEXT	"12Ha5364978xcb2o98m+"
#define ENCRYPT_PWD_SIZE	20


CDataCrypt::CDataCrypt()
{		
}

CDataCrypt::~CDataCrypt()
{	

}

bool CDataCrypt::IsEncryptedData(const char* pData, int nDataSize)
{
	char sDataOut[64000] = "\0";
	
	unsigned char sPwd[]  = ENCRYPT_PWD_TEXT;
	int nPwdSize = ENCRYPT_PWD_SIZE;
	
    CBlowFish objBlowFish;
	objBlowFish.Initialize(sPwd, nPwdSize);
	
	objBlowFish.Decode((unsigned char*) pData, (unsigned char*) sDataOut, nDataSize);
	    
    if(sDataOut[20] == 2 && sDataOut[21] == 26 && sDataOut[22] == 69 && sDataOut[23] == 23)
    {
        return true;
    }
    
    return false;
}

void CDataCrypt::EncryptData(char* pDataIn, int nSizeDataIn, char* pDataOut, int* pSizeDataOut)
{
	char sInputData[64000] = "\0";
	
	srand((unsigned)time(NULL));
    
	for(int nCount = 0; nCount < 20; nCount++)
		sInputData[nCount] = rand();
	
	sInputData[20] = 2;
	sInputData[21] = 26;
	sInputData[22] = 69;
	sInputData[23] = 23;
    
	memcpy(&sInputData[24], &nSizeDataIn, 4);
	memcpy(&sInputData[28], pDataIn, nSizeDataIn);
	
	unsigned char sPwd[] = ENCRYPT_PWD_TEXT;
	int nPwdSize = ENCRYPT_PWD_SIZE;
	
	CBlowFish objBlowFish;
	objBlowFish.Initialize(sPwd, nPwdSize);

	*pSizeDataOut = objBlowFish.Encode((unsigned char*) sInputData, (unsigned char*) pDataOut, nSizeDataIn + 28);
}

void CDataCrypt::DecryptData(char* pDataIn, int nSizeDataIn, char* pDataOut, int* pSizeDataOut)
{
	if(!IsEncryptedData(pDataIn, nSizeDataIn))
	{
		*pSizeDataOut = nSizeDataIn;
		memcpy(pDataOut, pDataIn, nSizeDataIn);
		return;
	}
	
	char sDataOut[64000] = "\0";
	
	unsigned char sPwd[] = ENCRYPT_PWD_TEXT;
	int nPwdSize = ENCRYPT_PWD_SIZE;
			
	CBlowFish objBlowFish;
	objBlowFish.Initialize(sPwd, nPwdSize);
	
	int nSizeDataOut = objBlowFish.GetOutputLength(nSizeDataIn);
	objBlowFish.Decode((unsigned char*) pDataIn, (unsigned char*) sDataOut, nSizeDataIn);
	
	int* pDataSize = (int*) &sDataOut[24];
	*pSizeDataOut = *pDataSize;
    
	if(*pSizeDataOut >= 256)
	{
		*pSizeDataOut = 256;
    }
	
	memcpy(pDataOut, &sDataOut[28], *pSizeDataOut);
}

